{% extends "layouts/presentations/unit_testing.njk" %}

{% set title = "Programming in C" %}
{% set subtitle = "Unit Testing" %}

{% set language = "C" %}
{% set language_ = language | lower %}


{% block framework %}
  <p class="fragment">At the time of this writing,
    <a href="https://github.com/Snaipe/Criterion">Criterion</a>
    offers the best features.
  </p>
{% endblock %}

{% block run_tests_before %}
{% highlight "shell" %}
clang before_refactoring.c test_sum_to.c -l criterion -o run_tests
./run_tests  # does not terminate; interrupt via [Ctrl]+[C]
{% endhighlight %}
<p>What to do now?</p>
<div class="fragment">
{% highlight "shell" %}
./run_tests --help
./run_tests -l  # list all available tests
./run_tests --filter sum_to/fast_test
{% endhighlight %}
</div>
{% endblock %}

{% block run_tests_after %}
{% highlight "shell" %}
clang after_refactoring.c test_sum_to.c -l criterion -o run_tests
./run_tests
{% endhighlight %}
{% endblock %}

{% block about_framework %}
<section>
  <h2>Criterion</h2>
  <p>The comprehensive documentation can be found on
    <a href="https://criterion.readthedocs.io/en/latest/intro.html">
    readthedocs</a>.
  </p>
  <p>The installation is trivial, if it's
    <a href="https://github.com/Snaipe/Criterion#downloads">available
    in your package manager</a>.</p>
  <p class="fragment">Otherwise, follow the
    <a href="https://criterion.readthedocs.io/en/latest/setup.html#setup">
    setup guide for building from source</a>.
  </p>
  <p class="fragment">A slightly
    <a href="https://github.com/HTL-Bulme/c_free_store/blob/main/int_array_test.c">
      more comprehensive example</a> also demonstrates
      <a href="https://en.wikipedia.org/wiki/Test_fixture">text fixtures</a>.
  </p>
</section>
{% endblock %}
